/**
 * Created by estratek on 1/12/17.
 */
let React = require('react');
import GfsInput from './GfsInput';
import GfsInputAction from './GfsInputAction';
import GfsInputTime from './GfsInputTime';
import GfsInputTextArea from './GfsInputTextArea';
import GfsInputFileImage from './GfsInputFileImage';
import GfsHyperLink from './GfsHyperLink';
import DynamicSelect from './DynamicSelect';
import GfsInputDatePicker from './GfsInputDatePicker';
import GfsInputPhone from './GfsInputPhone';
import GenericCrud from './GenericCrud/GenericCrud';
import PropTypes from 'prop-types';
import moment from 'moment';
import GfsInputDescriber from './GfsInputDescriber';
import { getArrayErrors } from './GfsValidator';
import axios from 'axios';

class GenericForm extends React.Component {
	state = {
		initialStructure: {}
	}
	componentDidMount = () => {
		this.sendOnChange(this.props.structure);
		this.setState({initialStructure: this.props.structure})
		Object.keys(this.props.structure).map((key) => {
			let tmpValue = this.props.structure[key];
			if(!!tmpValue && tmpValue.value) {
				this.replaceExpressions(key, tmpValue.value);
			}
		})
		if (!!this.props.rawData) {
		}
	};

	transformStructure(structure, readOnly, _currentvalues) {
		let auxStructure = { ...structure };
		let newStructure = this.passArrayToSubtype(auxStructure);
		newStructure = this.setCurrentPropsValues(newStructure, _currentvalues);
		newStructure = this.deleteHiddenInputs(newStructure);
		newStructure = this.addClassColToFields(newStructure);
		if (!!readOnly == true) {
			newStructure = this.addOnlyViewProp(newStructure);
		}
		newStructure = this.groupInputs(newStructure);
		return newStructure;
	}
	setCurrentPropsValues = (_structures = [], _values = []) => {
		return _structures.map((_x) => {
			if (typeof _values[_x.real_name] != 'undefined') {
				_x.value = _values[_x.real_name];
			}
			return _x;
		});
	};

	groupInputs = (_structureArray) => {
		let auxGroups = this.getAllTheDividers(_structureArray);
		let group = auxGroups.map((group) => ({
			nombre: group,
			inputs: _structureArray.filter((_field) => _field.formGroup === group)
		}));
		
		group.unshift({ nombre: 'default', inputs: _structureArray.filter((_field) => !_field.formGroup) });
		return group;
	};
	addOnlyViewProp = (_structureArray) => {
		return _structureArray.map((_val) => {
			_val.readOnly = true;
			return _val;
		});
	};

	deleteHiddenInputs = (structureWithHiddens) => {
		return structureWithHiddens.filter((value) => !value.hidden);
	};
	//for obj that are in [] transform that array in only obj.
	passArrayToSubtype(_structureObj) {
		return Object.keys(_structureObj).map((_fieldKey) => {
			if (_structureObj[_fieldKey] instanceof Array) {
				_structureObj[_fieldKey][0];
			} else {
				_structureObj[_fieldKey];
			}
			//add the key to the object as a "fieldkey"
			_structureObj[_fieldKey].real_name = _fieldKey;
			return _structureObj[_fieldKey];
		});
	}
	addClassColToFields = (_structureArray) => {
		return _structureArray.map((_field) => {
			if (
				_field.subtype == 'textarea' ||
				_field.subtype == 'file' ||
				_field.subtype == 'dynamictable' ||
				_field.subtype === 'range'
			) {
				if(!!_field.classCss && _field.classCss.indexOf('col')>=0){
					_field.classCss = (_field.classCss || 'col-md-12 ');
				}else{
					_field.classCss = 'col-md-12 '+ (_field.classCss || '');
				}
			} else {
				if(!!_field.classCss && _field.classCss.indexOf('col')>=0){
					_field.classCss = (_field.classCss || 'col-md-6 ');
				}else{
					_field.classCss = 'col-md-6 '+ (_field.classCss || '');
				}
			}
			return _field;
		});
	};
	getDescriberComponent = (input, structureObj) => {
		// let _structureObj = JSON.parse(JSON.stringify(structureObj))
		let _structureObj = { ...structureObj };
		if (!input || !_structureObj) return false;
		let keyDescriber = Object.keys(_structureObj).find(
			(_key) => !!_structureObj[_key].describer && _structureObj[_key].describer == input.real_name
		);

		let describer = _structureObj[keyDescriber];
		let obj = { ..._structureObj[keyDescriber], real_name: keyDescriber };
		if (!describer) return false;
		let props = (this.props.value && this.props.value.form) || {};
		return (
			<GfsInputDescriber
				{...obj}
				onChange={(e) => this.handleChange(keyDescriber, e)}
				host={obj.host || this.props.host}
				ref={null}
				value={props[keyDescriber]}
				model={obj.ref || obj.model}
				labelKey={obj.labelkey}
				valueKey={obj.valuekey}
			/>
		);
	};

	getInput  (_input)  {
		let input = '';
		if (_input instanceof Array) {
			if (_input.overWriteAdd || _input.overWriteEdit) {
				input = [ ..._input[0] ];
				input.real_name = _input.real_name;
			} else {
				input = JSON.parse(JSON.stringify(_input[0]));
				input.real_name = _input.real_name;
			}
		} else {
			if (_input.overWriteAdd || _input.overWriteEdit) {
				input = { ..._input };
			} else {
				input = JSON.parse(JSON.stringify(_input));
			}
		}
		// input.validation = JSON.parse(JSON.stringify(input));
		input.validation = { ...input };

		input.onChange = (e) =>  this.handleChange(input.real_name, e);
		// if(input.real_name == 'tipo_pago' || input.real_name == 'sede'){
		// 	console.log('input: ', input);
		// }
		input.host = input.host || this.props.host;
		input.model = input.ref || input.model;
		input.describerComponent = this.getDescriberComponent(input, this.props.structure);
		input.parentStructure = this.props.structure;

		if (input.type == 'date') {
			return <GfsInputDatePicker {...input} />;
		}		

		if (input.type == 'time') {
			return <GfsInputTime {...input} />;
		}
		if (input.type == 'boolean') {
			return <GfsInput {...input} type="checkbox" />;
		}
		if ((input.type == 'array' && input.subtype == 'ref') || input.subtype == 'ref') {
			let aux = { ...input };
			delete aux.ref;
			if (input.options) {
				return (
					<DynamicSelect
						{...aux}
						type={'ref'}
						labelKey={input.labelkey}
						options={input.options}
						valueKey={input.valuekey}
						axiosInstance={this.props.axiosInstance}
					/>
				);
			}
			return (
				<DynamicSelect
					{...aux}
					type={'ref'}
					labelKey={input.labelkey}
					valueKey={input.valuekey}
					axiosInstance={this.props.axiosInstance}
				/>
			);
        }
        if (input.type == 'number') {
			return <GfsInput {...input} />;
		}
		if (!!input.ref && input.subtype == 'dynamictable') {
			let aux = { ...input };
			delete aux.ref;
			let data = null;
			return (
				<GenericCrud
					{...aux}
					title={input.label || input.real_name}
					hideVia={input.hideVia != undefined ? input.hideVia : true}
					saveRelationsAfterSave={input.saveRelationsAfterSave != undefined ? input.saveRelationsAfterSave : true}
					populateInFrontEnd={true}
					viaValue={this.props.editingId}
					viaRelation={input.via}
					rawData={(!!this.props.rawData && !!this.props.rawData[input.real_name] && this.props.rawData[input.real_name][0] && typeof(this.props.rawData[input.real_name][0]) == 'object') ? this.props.rawData[input.real_name]: null}
					hideOptionsButton={this.props.hideOptionsButton || false}
					dontUseRawData={this.props.dontUseRawData || false}
  					expandRow={ this.props.expandRow }
				/>
			);
		}
		if (input.type == 'text' || input.type == 'string') {
			if (input.subtype == 'phone') {
				return <GfsInputPhone {...input} />;
			}
			if (input.subtype == 'textarea') {
				return <GfsInputTextArea {...input} />;
			}
			if (input.subtype == 'time') {
				return <GfsInputTime {...input} />;
			}
			if (input.subtype == 'file') {
				return (
					<GfsInputFileImage
						{...input}
						disabledButtonWhenUploading={this.props.disabledButtonWhenUploading}
					/>
				);
			}
			if (input.subtype == 'link') {
				return <GfsHyperLink {...input} />;
			}
			if (input.subtype == 'password' || input.subtype == 'email') {
				return <GfsInput {...input} type={input.subtype} />;
			}
			if (input.accionInput == true) {
				if(input.onlynumber == true){
					return <GfsInputAction {...input} type={'number'} step={1}/>;
				}else{
					return <GfsInputAction {...input} type={'text'}/>;
				}
				
			}
			return <GfsInput {...input} type={'text'} />;
		}
	}

	// this is mine
	getAllTheDividers = (_structure) => [
		...new Set(_structure.filter((el) => el.formGroup).map((el) =>  el.formGroup ))
	];
	// this is mine
	getExpressionsInObj = (json) => {
		let jsonString = JSON.stringify(json);
		const patron = /\{\{([^{}]+)\}\}/g;
		const expresiones = jsonString.match(patron) || [];
		return expresiones;
	}
	replaceExpressions = (real_name, newVal) => {
		let _newArray = { ...this.props.structure };
		if (this.getExpressionsInObj(_newArray).filter(exp => exp == `{{${real_name}}}`).length>0) {
			// Existe mas de algun otro campo el cual depende de este campo.
			_newArray = this.setValueOnExpressions(real_name, newVal, _newArray, this.props.structure);
		}
		this.sendOnChange(_newArray);
	}
	handleChange = (real_name, newVal) => {
		// let _newArray = JSON.parse(JSON.stringify(this.props.structure));
		let _newArray = { ...this.props.structure };
		!!_newArray[real_name] && (_newArray[real_name].value = newVal);

		//RANGE DATES TRANSFORM STRUCTURE
		if (_newArray[real_name].rangeDate) {
		_newArray = this.setConfigDateRange(real_name, newVal, _newArray);
		}
		if (_newArray[real_name].rangeInt) {
			_newArray = this.setConfigIntRange(real_name, newVal, _newArray);
		}
		if (this.getExpressionsInObj(this.state.initialStructure).filter(exp => exp == `{{${real_name}}}`).length>0) {
			// Existe mas de algun otro campo el cual depende de este campo.
			_newArray = this.setValueOnExpressions(real_name, newVal, _newArray, this.state.initialStructure);
		} 
		
		Object.keys(_newArray).map((x) => {
			if (!!_newArray[x] && !!_newArray[x].requiredOn) {
				//obtengo el primer key del requiredOn para buscarlo dentro del changes.form
				let valueKey = Object.keys(_newArray[x].requiredOn)[0];

				// verifico que el campo tenga un operador y un valor
				if(!!_newArray[x].requiredOn[valueKey].operador && !!_newArray[x].requiredOn[valueKey].valor){
					
					let operator = _newArray[x].requiredOn[valueKey].operador;
					let valor = _newArray[x].requiredOn[valueKey].valor;
					//tomo el operador y mediante un switch valido si es igual, diferente, mayor, menor, mayor o igual, menor o igual
					switch(operator){
						case '==':
							if(this.state.initialStructure[valueKey].value == valor){
								_newArray[x].required = true;
							}else{
								_newArray[x].required = false;
							}
							break;
						case '!=':
							if(this.state.initialStructure[valueKey].value != valor){
								_newArray[x].required = true;
							}else{
								_newArray[x].required = false;
							}
							break;
						case '>':
							if(this.state.initialStructure[valueKey].value > valor){
								_newArray[x].required = true;
							}else{
								_newArray[x].required = false;
							}
							break;
						case '<':
							if(this.state.initialStructure[valueKey].value < valor){
								_newArray[x].required = true;
							}else{
								_newArray[x].required = false;
							}
							break;
						case '>=':
							if(this.state.initialStructure[valueKey].value >= valor){
								console.log('mayor o igual');
								_newArray[x].required = true;
							}else{
								_newArray[x].required = false;
							}
							break;
						case '<=':
							if(this.state.initialStructure[valueKey].value <= valor){
								_newArray[x].required = true;
							}else{
								_newArray[x].required = false;
							}
							break;
						default:
							break;
					}
					
				}
				
			}
		});
		this.sendOnChange(_newArray);
	};

	setValueOnExpressions = (real_name, newVal, _structure, _initialStructure) => {
		// Las dependencias son referencias a otros campos y se puede agregar en cualquiera de las siguientes propiedades		
		const replaceExpression = (_expression) => {
			if(_expression.indexOf("{") < 0) return _expression;
			return newVal;
		}
		Object.keys(_initialStructure).map(key => {
			let expressions = this.getExpressionsInObj(_initialStructure[key]).filter(exp => exp == `{{${real_name}}}`);
			if (expressions.length>0) {
				let jsonString = JSON.stringify(_initialStructure[key]);
				expressions.map((expression)=>{
					jsonString = jsonString.replace(expression,replaceExpression(expression));
				});
				_structure[key] = {
					...JSON.parse(jsonString)
				};
			}
		});
		return _structure;
	};
	setConfigDateRange = (real_name, newVal, _structure) => {
		// let structure = JSON.parse(JSON.stringify(_structure));
		let structure = { ..._structure };
		let updatedDate = structure[real_name];
		/* FIND START DATE */
		let firstDateKey = Object.keys(_structure).find((x) => {
			return (
				_structure[x].rangeDate &&
				_structure[x].rangeDate.id == updatedDate.rangeDate.id &&
				_structure[x].rangeDate.pos == 'start'
			);
		});

		/* FIND END DATE */
		let lastDateKey = Object.keys(_structure).find((x) => {
			return (
				_structure[x].rangeDate &&
				_structure[x].rangeDate.id == updatedDate.rangeDate.id &&
				_structure[x].rangeDate.pos == 'end'
			);
		});
		if (structure[firstDateKey]) {
			structure[firstDateKey] = {
				...structure[firstDateKey],
				selectsStart: true,
				startDate: structure[firstDateKey].value || null,
				endDate: structure[lastDateKey].value || null
			};
		}
		if (structure[lastDateKey]) {
			structure[lastDateKey] = {
				...structure[lastDateKey],
				selectsEnd: true,
				startDate: structure[firstDateKey].value || null,
				endDate: structure[lastDateKey].value || null
			};
		}
		return structure;
	};

	setConfigIntRange = (real_name, newVal, _structure) => {
		// let structure = JSON.parse(JSON.stringify(_structure));
		let structure = { ..._structure };
		let updatedInt = structure[real_name];
		/* FIND START INT */
		let firstIntKey = Object.keys(_structure).find((x) => {
			return (
				_structure[x].rangeInt &&
				_structure[x].rangeInt.id == updatedInt.rangeInt.id &&
				_structure[x].rangeInt.pos == 'start'
			);
		});

		/* FIND END INT */
		let lastIntKey = Object.keys(_structure).find((x) => {
			return (
				_structure[x].rangeInt &&
				_structure[x].rangeInt.id == updatedInt.rangeInt.id &&
				_structure[x].rangeInt.pos == 'end'
			);
		});
		
		if (structure[firstIntKey]) {
			structure[firstIntKey] = {
				...structure[firstIntKey],
				max: structure[lastIntKey].value || null
			};
		}
		if (structure[lastIntKey]) {
			structure[lastIntKey] = {
				...structure[lastIntKey],
				min: structure[firstIntKey].value || null
			};
		}
		return structure;
	};

	sendOnChange =  (newArray) => {
		let newStructureParsed = this.prepareDataToSend(newArray);
		let currentPropValue = newStructureParsed || {};
		let arrayErrors = {};
		
		arrayErrors =  this.checkIfFormHasError(newArray, currentPropValue);
		//avoid to redraw if there where no error or new changes
		this.props.onChange({
			form: newStructureParsed,
			hasError: Object.keys(arrayErrors).length > 0,
			arrayErrors: arrayErrors,
			structure: newArray
		});
	};

	checkIfFormHasError(_structure, _currentValues) {
		// let auxStructure = JSON.parse(JSON.stringify(_structure))
		let auxStructure = { ..._structure };

		let newStructure = this.passArrayToSubtype(auxStructure);
		newStructure = this.setCurrentPropsValues(newStructure, _currentValues);
		
		let arrayErrors = {};
		newStructure.map( (_input) => {
			let auxVal =  getArrayErrors(_input, _input.value);
			
			if (auxVal.length > 0) {
				arrayErrors[_input.real_name] = auxVal;
			}
		});
		return arrayErrors;
	}
	prepareDataToSend(data) {
		// let newArray = JSON.parse(JSON.stringify(this.props.value && this.props.value.form || {}));
		let newArray = { ...((this.props.value && this.props.value.form) || {}) };
		for (let value in data) {
			if (typeof data[value].value !== 'undefined') {
				newArray[value] = data[value].value;
			}
		}
		return newArray;
	}

	render() {
		let currentPropValue = (this.props.value && this.props.value.form) || {};
		let transformedStructure = this.transformStructure(this.props.structure, this.props.readOnly, currentPropValue);
		return (
			<div id="_stk_gforms"  className={`row stk-gforms generic-form ${this.props.cssClass || 'row'}`}>
				{transformedStructure &&
					transformedStructure.map((_group, _key) => (
						<React.Fragment key={_key}>
							{!!_group.inputs.length > 0 && (
								<div key={`cf_form${_key}`} className="container-fluid">
									<div className="row">
										<div className="col-md-12">
											{_group.nombre === 'default' ? (
												''
											) : (
												<div className="row separator-group">
													<div className="col-md-12 form-section-Title">
														<h5>
															<span>{_group.nombre}</span>
														</h5>
													</div>
													{_group.inputs[0].formGroupDescripcion && (
														<div className="col-md-12 form-section-description">
															<h5>
																<span>{_group.inputs[0].formGroupDescripcion}</span>
															</h5>
														</div>
													)}
												</div>
											)}
										</div>
										{_group.inputs.map(
											(_field, _key) =>
												!!!_field.describer ? (
													<div
														key={`${_group.name}_child_${_key}`}
														className={_field.classCss}
													>
														{this.getInput(_field)}
													</div>
												) : null
										)}
									</div>
								</div>
							)}
						</React.Fragment>
					))}
			</div>
		);
	}
}

GenericForm.propTypes = {
	host: PropTypes.string,
	transformStructure: PropTypes.func,
	onChange: PropTypes.func.isRequired,
	readOnly: PropTypes.bool,
	value: PropTypes.object,
	axiosInstance: PropTypes.instanceOf(axios)
};
GenericForm.defaultProps = {
	readOnly: false,
	onChange: () => {},
	transformStructure: (_structure) => _structure
};

export default GenericForm;
