/**
 * Created by estratek on 15/12/17.
 */
//import React, {Component} from 'react';
//import {Modal}
//import Prueba from './Prueba';
import { shallow, mount } from 'enzyme';
import sinon from 'sinon';
import GenericFormApi from './GenericFormApi';
import axios from 'axios';
import MockAdapter from 'axios-mock-adapter';
import React, { Component } from 'react';
import sleep from 'await-sleep'

describe('GenericForm', () => {
    describe('Renderizado', () => {
        it('debe renderizar todos dependiendo de la estructura que manda a llamar en la API', async () => {
            const timeout = ms => new Promise(res => setTimeout(res, ms))
            let mock = new MockAdapter(axios);
            const data = { response: true };
            mock.onGet('localhost/persona/usuario').reply(200, data);
            mock.onGet('localhost/persona/structure/usuario').reply(200, {
                structure:
                    JSON.stringify({
                        nombre: { type: 'text' },
                        apellido: { type: 'text' }
                    })
            }, { delayResponse: 0 });
            let comp = mount(
                <GenericFormApi
                    host={"localhost"}
                    model={"usuario"}
                    microservice={"persona"}
                />)
            expect(comp.find('.progress.progress-lg.progress-bar-striped').length).toBeGreaterThanOrEqual(1);
            await sleep(500);
            expect(comp.find('div.stk-Forms-loading')).toHaveLength(1);
        });
    })

});
