/**
 * Created by estratek on 15/12/17.
 */
import GfsValidator, { getArrayErrors } from './GfsValidator'
import PropTypes from 'prop-types';
import GfsOnlyView from './GfsOnlyView';
import GfsDescriptionPopOver from './GfsDescriptionPopOver'
var React = require('react');
import PhoneInput from 'react-phone-input-2'
import 'react-phone-input-2/lib/style.css'

class GfsInput extends React.Component {
    state={
        popoverOpen:false,
    }
    componentWillUpdate(nextProps) {
        if (nextProps.value !== this.props.value && !!this.props.onChangeError) {
            let newErrorState = getArrayErrors(nextProps.validation, nextProps.value).length > 0;
            this.props.onChangeError(newErrorState);
        }
    }
    componentDidMount() {   
        
        this.props.onChangeError(this.hasError());
    }
    handleChange = (newVal) => {
        this.props.onChange(newVal);
    }
    hasError = () => {
        return getArrayErrors(this.props.validation, this.props.value).length > 0
    }

    render() {
        if (this.props.readOnly) {
            return (<GfsOnlyView label={this.props.label} valueString={this.props.value} />)
        }
        return (
            <div className="mb-2 gfs-input gfs-input-text">                
                <div className={(!this.props.classWrapp ? "form-group input-group input-group-dropdown mb-0 " : this.props.classWrapp) +
					' ' +
					(this.hasError() ? 'has-error' : '')}>
                    <label className="form-control-label mb-1"> <strong> {this.props.label}</strong>
                        {this.props.description && <GfsDescriptionPopOver description={this.props.description} />}
                    </label>
                    {!!this.props.describerComponent && this.props.describerComponent}
                    <PhoneInput
                        className={"form-control class" + ((this.hasError()) ? 'form-control-danger' : '')}
                        country={this.props.country || 'gt'}
                        value={this.props.value}
                        onChange={this.handleChange}
                        disabled={this.props.disabled}
                        placeholder={this.props.placeHolder || ''}
                        inputProps={{
                            name: 'phone',
                            required: this.props.required,
                            autoFocus: this.props.autoFocus,
                            enableAreaCodes: this.props.enableAreaCodes,
                            defaultErrorMessage: this.props.defaultErrorMessage,
                        }}
                    />
                </div>
            </div>
        );
    }
}




GfsInput.propTypes = {
    disabled: PropTypes.bool,
    type: PropTypes.string,
    validation: PropTypes.object,
    value: PropTypes.string.isRequired,
    onChange: PropTypes.func,
    onChangeError: PropTypes.func,
    description: PropTypes.string,
    placeHolder: PropTypes.string,
    hasError: PropTypes.bool,
    label: PropTypes.string,
    readOnly: PropTypes.bool
};
GfsInput.defaultProps = {
    disabled: false,
    type: 'text',
    validation: {},
    value: '',
    onChange: () => { },
    onChangeError: () => { },
    description: "",
    placeHolder: "",
    hasError: false,
    label: "",
    readOnly: false
};

export default GfsInput;