import React, { Component } from 'react'
import PropTypes from 'prop-types'
var Modal = require('reactstrap').Modal;
const regex = /"([^"]*)"|'([^']*)'/g

class ModalError extends Component {
     state = {
        isOpen: true,
        message:''
    }
    componentDidMount =async ()=>{
        await this.validaciones(this.props); 
    }
    validaciones =async (props)=>{
       if(!!props.value && !!props.value.response && !!props.value.response.data){
            if(!!props.value.response.data.invalidAttributes){
                let firsterror ='';
                
                let atributos = Object.values(props.value.response.data.invalidAttributes)
                atributos.map(
                    error => {
                        firsterror = error[0].message
                    }
                );
                this.setState({message:firsterror}) ;
            }
            else if(!!props.value.response.data.message) {
                if(!!props.value.response.data.code && props.value.response.data.code == 'E_UNIQUE' && !!props.value.response.data.message){
                    this.setState({message:'Registro ya existe, no es posible agregar otro con los mismos valores'}) ;
                }else{
                    this.setState({message:props.value.response.data.message}) ;
                }
            }
            else if(!!props.value.response.data.error && !!props.value.response.data.error.message){
                this.setState({message:props.value.response.data.error.message}) ;
            }else if(!!props.value.response.data.error && !props.value.response.data.error.message){
                this.setState({message:props.value.response.data.error}) ;
            }
            else if(!!props.value.response.data.raw) {
                this.setState({message:props.value.response.data.raw}) 
            } 
            else if(typeof props.value.response.data == 'string') {
                let message = props.value.response.data;
                if (message.includes('Envelope')) {
                    message = regex.exec(props.value.response.data)[2];
                }
                this.setState({message}) 
            }else {
                this.setState({message:'Error no contemplado'}) 
            }
        }else {
            this.setState({message:'Error no contemplado'}) 
        }
    }
    componentWillReceiveProps = async nextProps =>{
        
        await this.validaciones(nextProps);
    }

    render() {
        return (
            <div>
                <Modal isOpen={this.props.value}>
                    <div className="modal-header">
                        ERROR
              </div>
                    <div className="modal-body row">
                        {this.props.value && this.props.value.response
                        && this.props.value.response.data 
                        &&
                            <React.Fragment>
                                <div className="col-md-2 text-center">
                                    <h5>
                                        <i className="fa fa-exclamation-circle f-50 text-danger" aria-hidden="true"></i>
                                    </h5>
                                </div>
                                <div className="col-md-10">
                                    <h5>
                                        {
                                            this.state.message
                                        }
                                    </h5>
                                </div>
                            </React.Fragment>
                        }
                    </div>
                    <div className="modal-footer">
                        <button className="btn btn-default" onClick={this.props.onAccept}>Aceptar</button>
                    </div>
                </Modal>
            </div>
        )
    }
}

export default ModalError;