import React, { Component } from "react";
import { Modal, ModalHeader, ModalBody, ModalFooter, Button } from "reactstrap";
import AvatarEditor from "react-avatar-editor";

export default class StkCropImage extends Component {
  state = {
    image: null
  }; 

  componentDidMount = () => {
    this.setState({ image: this.props.image})
  };
  componentWillReceiveProps = (nextProps) => {
    this.setState({ image: nextProps.image})
  }

  toggle = () => {
    this.setState({ image: null });
    this.props.toggle();
  };

  handleNewImage = e => {
    this.setState({ image: e.target.files[0] });
  };

  setEditorRef = editor => {
    if (editor) this.editor = editor;
  };

  setInputRef = input => {
    if (input) this.inputElement = input;
  }

  handleSave = data => {
    const img = this.editor.getImageScaledToCanvas().toDataURL();
    const rect = this.editor.getCroppingRect();
    this.props.handleSaveCrop(img, rect);
    this.toggle();
    // this.setState({
    //   preview: {
    //     img,
    //     rect,
    //     scale: this.state.scale,
    //     width: this.state.width,
    //     height: this.state.height,
    //     borderRadius: this.state.borderRadius,
    //   },
    // },)
  };

  tryClick() {
    this.inputElement.click();
  }

  render() {
    return (
      <div>
        <Modal isOpen={this.props.isOpen} toggle={this.toggle}>
          <ModalHeader toggle={this.toggle}></ModalHeader>
          <ModalBody>
            <div
              className="text-center"
              style={{
                display: "flex",
                flexDirection: "column",
                alignItems: "center"
              }}
            >
              {this.state.image && (
                <AvatarEditor
                  ref={this.setEditorRef}
                  image={this.state.image}
                  width={250}
                  height={250}
                  border={50}
                  scale={1.2}
                />
              )}
              <input
                ref={this.setInputRef}
                hidden
                name="newImage"
                type="file"
                onChange={this.handleNewImage}
              />
            </div>
          </ModalBody>
          <ModalFooter>
            <Button color="default" onClick={this.handleSave}>
              RECORTAR
            </Button>{" "}
          </ModalFooter>
        </Modal>
      </div>
    );
  }
}
