var React = require("react");
var axios = require("axios");
import { ClipLoader } from "react-spinners";
import ModalCrop from "./StkCropImage";
import { base64ImageToImageRawData } from "base64-image-utils";

//

export default class UploadMyFile extends React.Component {
  constructor() {
    super();
    this.state = { valueFile: "", loading: false, openModalCrop: false, imageToCrop: null };
  }

  componentWillReceiveProps(nextProps) {
    this.setState(() => ({ loading: !nextProps.flagOfRenderIMG }));
  }

  asyncBase64ToImage = async base64String => {
      let x = new Promise((resolve, reject) => {
        base64ImageToImageRawData(base64String, (err, succes, img) => {
            if (err) {
                reject(err)
            }
            resolve(succes)
        })
      })

      return x;
  }

  handleSaveCrop = async (file, rec) => {
    let pos = file.indexOf(';base64,');
    let type = file.substring(5, pos);
    let b64 = file.substr(pos + 8);
    // decode
    let imageContent = atob(b64);

    let buffer = new ArrayBuffer(imageContent.length);
    let view = new Uint8Array(buffer);
    for (let n = 0; n < imageContent.length; n++) {
        view[n] = imageContent.charCodeAt(n);
    }
    let blob = new Blob([buffer], { type });
    blob.lastModifiedDate = new Date();
    blob.name = 'avatar_.png'
    let _otherFile = new File([blob], 'avatar_.png')
    this.props.renderIMG(false);
    this.setState(() => ({ loading: true }));
    let self = this;
    await this.uploadFileAjax(_otherFile).then((res)=>this.props.onUploaded(res));
    this.setState(() => ({ loading: false }));
  };

  handleUploadFile = async event => {
    this.props.renderIMG(false);
    this.setState(() => ({ loading: true }));
    // console.log('cambio',event);
    let self = this;
    // console.log("files", event.target.files[0]);
    await this.uploadFileAjax(event.target.files[0]).then(res =>
      this.props.onUploaded(res)
    );
    this.setState(() => ({ loading: false }));
  };

  uploadFileAjax = async file => {
    const data = new FormData();
    data.append("file", file);
    if (!!this.props.paramsApi) {
      Object.keys(this.props.paramsApi).map((key)=>{
        data.append(key, this.props.paramsApi[key]);
      })
    }
    return axios.post(
      "https://apipersona.estratek.com/upload/uploadFile",
      data
    );
  };

  handleNewImage = e => {
    this.setState({ imageToCrop: e.target.files[0], openModalCrop: true });
  }

  tryClick() {
    // this.simulateClick();
    // if (this.props.isImage) {
    // } else {
      this.inputElement.click();
    // }
  }

  toggleModalCrop = () => {
    this.setState({ openModalCrop: !this.state.openModalCrop });
  };
  render() {
    return (
      <div>
        <div
          onClick={this.tryClick.bind(this)}
        >
          {this.state.loading ? (
            <div className="stk-Forms-loading">
              {" "}
              <ClipLoader width={50} />{" "}
            </div>
          ) : (
            this.props.elementToShow
          )}
        </div>
        <input
          type="file"
          onChange={!this.props.isImage ? this.handleUploadFile.bind(this): this.handleNewImage}
          ref={input => (this.inputElement = input)}
          hidden
          value={this.state.valueFile}
        />
        {
          <ModalCrop
            image={this.state.imageToCrop}
            isOpen={this.state.openModalCrop}
            toggle={this.toggleModalCrop}
            handleSaveCrop={this.handleSaveCrop}
          />
        }
      </div>
    );
  }
}
